from __future__ import annotations

import ipaddress
import typing

from .app import app


@app.add_template_test
def ip_in_networks(ip_s: str, networks: typing.Iterable[str]) -> bool:
    ip = ipaddress.ip_address(ip_s)
    for network in networks:
        net = ipaddress.ip_network(network)
        if ip in net:
            return True
    return False
