import typing

import google.protobuf.message

# manually maintained typehints for protobuf created (and monkey-patched) types

class Message(google.protobuf.message.Message):
    hello: Hello
    authentication_result: AuthenticationResult
    ping: Ping
    mac_states: MacStates

    def __init__(
        self,
        *,
        hello: Hello | None = None,
        authentication_result: AuthenticationResult | None = None,
        ping: Ping | None = None,
        mac_states: MacStates | None = None,
    ) -> None: ...
    def to_variant(self) -> Hello | AuthenticationResult | Ping | MacStates | None: ...

class Hello(google.protobuf.message.Message):
    instance_id: bytes
    hostname: str
    is_controller: bool
    authentication: bytes

    def __init__(
        self,
        *,
        instance_id: bytes = b"",
        hostname: str = "",
        is_controller: bool = False,
        authentication: bytes = b"",
    ) -> None: ...
    def to_message(self) -> Message: ...

class AuthenticationResult(google.protobuf.message.Message):
    success: bool

    def __init__(
        self,
        *,
        success: bool = False,
    ) -> None: ...
    def to_message(self) -> Message: ...

class Ping(google.protobuf.message.Message):
    payload: bytes

    def __init__(
        self,
        *,
        payload: bytes = b"",
    ) -> None: ...
    def to_message(self) -> Message: ...

class MacStates(google.protobuf.message.Message):
    states: list[MacState]

    def __init__(
        self,
        *,
        states: list[MacState] = [],
    ) -> None: ...
    def to_message(self) -> Message: ...

class MacState(google.protobuf.message.Message):
    mac_address: bytes
    last_change: int  # Seconds of UTC time since epoch
    allow_until: int  # Seconds of UTC time since epoch
    allowed: bool

    def __init__(
        self,
        *,
        mac_address: bytes = b"",
        last_change: int = 0,
        allow_until: int = 0,
        allowed: bool = False,
    ) -> None: ...
