from __future__ import annotations

import logging

import capport.config


def init_logger(config: capport.config.Config):
    loglevel = logging.INFO
    if config.debug:
        loglevel = logging.DEBUG
    logging.basicConfig(
        format="%(asctime)s [%(name)-25s] [%(levelname)-8s] %(message)s",
        datefmt="[%Y-%m-%d %H:%M:%S %z]",
        level=loglevel,
    )
    logging.getLogger("hypercorn").propagate = False
