from __future__ import annotations

import zoneinfo

_zoneinfo: zoneinfo.ZoneInfo | None = None


def get_local_timezone():
    global _zoneinfo
    if not _zoneinfo:
        try:
            with open("/etc/timezone") as f:
                key = f.readline().strip()
                _zoneinfo = zoneinfo.ZoneInfo(key)
        except (OSError, zoneinfo.ZoneInfoNotFoundError):
            _zoneinfo = zoneinfo.ZoneInfo("UTC")
    return _zoneinfo
